unit ucuHelloWorld;


interface

uses
  utuStateMachine, utuRequest, ucuUseCase, utuMessage;

type
  ucHelloWorld = class(ucUseCase)
  private
    fNome: String;
  public
    procedure Initialize; Override;
    procedure Finalize; Override;
  published
    procedure Effect_Cumprimentar(piRequest: utRequest; piTransition: utTransition);
    procedure Effect_Despedir(piRequest: utRequest; piTransition: utTransition);
  end;

implementation

uses
  ucuManager;

procedure ucHelloWorld.Initialize;
begin
  inherited;
end;

procedure ucHelloWorld.Finalize;
begin
  
  inherited;
end;

procedure ucHelloWorld.Effect_Cumprimentar(piRequest: utRequest; piTransition: utTransition);
var
  lFieldCumprimento: utField;
begin
  fNome := piRequest.Message.RootField.FieldByName('Nome').AsString;
  lFieldCumprimento := piRequest.Response.RootField.AddField('Cumprimento');
  lFieldCumprimento.asString := 'Ol, ' + fNome;
  piRequest.Processed := True;
end;

procedure ucHelloWorld.Effect_Despedir(piRequest: utRequest; piTransition: utTransition);
var
  lFieldDespedida: utField;
begin
  lFieldDespedida := piRequest.Response.RootField.AddField('Despedida');
  lFieldDespedida.asString := 'Tchau, ' + fNome;
  piRequest.Processed := True;
end;

initialization

  gucManager.RegisterClass(3215,ucHelloWorld);

end.
