unit utuEmprestimoOQL;

interface

uses acuOQL, acuFramework;

type

  IContarEmprestimosExemplar = interface(IDataSetOQLQuery)
    function Param_oid: acOQLParamInt;
  end;

  IContarEmprestimosLivro = interface(IDataSetOQLQuery)
    function Param_oid: acOQLParamInt;
  end;

  IObterClientes = interface(IOQLQuery)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  IObterEmprestimos = interface(IOQLQuery)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  IObterExemplares = interface(IOQLQuery)
    function Param_titulo: acOQLParamString;
    function Param_codigo: acOQLParamString;
  end;

  IObterLivros = interface(IOQLQuery)
    function Param_titulo: acOQLParamString;
    function Param_autor: acOQLParamString;
  end;

  utEmprestimoOQL = class
    class function ContarEmprestimosExemplar(piSessao: acPersistenceSession): IContarEmprestimosExemplar;
    class function ContarEmprestimosLivro(piSessao: acPersistenceSession): IContarEmprestimosLivro;
    class function ObterClientes(piSessao: acPersistenceSession): IObterClientes;
    class function ObterEmprestimos(piSessao: acPersistenceSession): IObterEmprestimos;
    class function ObterExemplares(piSessao: acPersistenceSession): IObterExemplares;
    class function ObterLivros(piSessao: acPersistenceSession): IObterLivros;
  end;

implementation

type

  TContarEmprestimosExemplar = class(acDataSetOQLQuery, IContarEmprestimosExemplar)
    function Param_oid: acOQLParamInt;
  end;

  TContarEmprestimosLivro = class(acDataSetOQLQuery, IContarEmprestimosLivro)
    function Param_oid: acOQLParamInt;
  end;

  TObterClientes = class(acOQLQuery, IObterClientes)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  TObterEmprestimos = class(acOQLQuery, IObterEmprestimos)
    function Param_nome: acOQLParamString;
    function Param_cpf: acOQLParamString;
  end;

  TObterExemplares = class(acOQLQuery, IObterExemplares)
    function Param_titulo: acOQLParamString;
    function Param_codigo: acOQLParamString;
  end;

  TObterLivros = class(acOQLQuery, IObterLivros)
    function Param_titulo: acOQLParamString;
    function Param_autor: acOQLParamString;
  end;

{ TContarEmprestimosExemplar }

function TContarEmprestimosExemplar.Param_oid: acOQLParamInt;
begin
  result := acOQLParamInt(Self.ParamByName('oid'));
end;

{ TContarEmprestimosLivro }

function TContarEmprestimosLivro.Param_oid: acOQLParamInt;
begin
  result := acOQLParamInt(Self.ParamByName('oid'));
end;

{ TObterClientes }

function TObterClientes.Param_nome: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('nome'));
end;

function TObterClientes.Param_cpf: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('cpf'));
end;

{ TObterEmprestimos }

function TObterEmprestimos.Param_nome: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('nome'));
end;

function TObterEmprestimos.Param_cpf: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('cpf'));
end;

{ TObterExemplares }

function TObterExemplares.Param_titulo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('titulo'));
end;

function TObterExemplares.Param_codigo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('codigo'));
end;

{ TObterLivros }

function TObterLivros.Param_titulo: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('titulo'));
end;

function TObterLivros.Param_autor: acOQLParamString;
begin
  result := acOQLParamString(Self.ParamByName('autor'));
end;

{ utOQLs }

class function utEmprestimoOQL.ContarEmprestimosExemplar(piSessao: acPersistenceSession): IContarEmprestimosExemplar;
begin
  result := TContarEmprestimosExemplar.Create(pisessao,
'SELECT count(*) as qnt' + #13#10 +
'FROM ngExemplar,' + #13#10 +
'     ngExemplar.Emprestimos' + #13#10 +
'WHERE ngExemplar.OID = ?oid:acInt');
end;

class function utEmprestimoOQL.ContarEmprestimosLivro(piSessao: acPersistenceSession): IContarEmprestimosLivro;
begin
  result := TContarEmprestimosLivro.Create(pisessao,
'SELECT count(*) as qnt' + #13#10 +
'FROM ngLivro,' + #13#10 +
'     ngLivro.Exemplares,' + #13#10 +
'     ngLivro.Exemplares.Emprestimos' + #13#10 +
'WHERE ngLivro.OID = ?oid:acInt');
end;

class function utEmprestimoOQL.ObterClientes(piSessao: acPersistenceSession): IObterClientes;
begin
  result := TObterClientes.Create(pisessao,
'SELECT ngCliente' + #13#10 +
'FROM ngCliente' + #13#10 +
'WHERE ((ngCliente.Nome LIKE ''%''+?nome:acString+''%'' OR ?nome:acString IS NULL) AND ngCliente.Ativo = "1")' + #13#10 +
'	AND ((ngCliente.CPF = ?cpf:acString OR ?cpf:acString IS NULL) AND ngCliente.Ativo = "1")');
end;

class function utEmprestimoOQL.ObterEmprestimos(piSessao: acPersistenceSession): IObterEmprestimos;
begin
  result := TObterEmprestimos.Create(pisessao,
'SELECT ngEmprestimo' + #13#10 +
'FROM ngEmprestimo' + #13#10 +
'WHERE (ngEmprestimo.Cliente.Nome LIKE ''%''+?nome:acString+''%'' OR ?nome:acString IS NULL)' + #13#10 +
'	AND (ngEmprestimo.Cliente.CPF = ?cpf:acString OR ?cpf:acString IS NULL)');
end;

class function utEmprestimoOQL.ObterExemplares(piSessao: acPersistenceSession): IObterExemplares;
begin
  result := TObterExemplares.Create(pisessao,
'SELECT ngExemplar' + #13#10 +
'FROM ngExemplar' + #13#10 +
'WHERE (ngExemplar.Livro.Titulo LIKE ''%''+?titulo:acString+''%'' OR ?titulo:acString IS NULL)' + #13#10 +
'	AND (ngExemplar.Codigo = ?codigo:acString OR ?codigo:acString IS NULL)' + #13#10 +
'ORDER BY ngExemplar.Livro.OID');
end;

class function utEmprestimoOQL.ObterLivros(piSessao: acPersistenceSession): IObterLivros;
begin
  result := TObterLivros.Create(pisessao,
'SELECT ngLivro' + #13#10 +
'FROM ngLivro' + #13#10 +
'WHERE (ngLivro.Titulo LIKE ''%''+?titulo:acString+''%'' OR ?titulo:acString IS NULL)' + #13#10 +
'	AND (ngLivro.Autor = ?autor:acString OR ?autor:acString IS NULL)');
end;

end.
